Atividade2/urls.py
from django.contrib import admin
from django.urls import include, path # modificar esta linha

urlpatterns = [
    path('', include('static.urls')), # adicionar esta linha
    path('receitas/', include('receitas.urls')),
    path('admin/', admin.site.urls),
]

receitas/urls.py
from django.urls import path

from . import views

app_name = 'receitas'
urlpatterns = [
    path('', views.list_receita.as_view(), name='index'),
    path('categories/', views.list_cat.as_view(), name='categorias'),
    path('categories/<int:pk>/', views.detail_cat.as_view(), name='cat_indiv'),
    path('create/', views.create_receita, name='create'),
    path('update/<int:receita_id>/', views.update_receita, name='update'),
    path('delete/<int:pk>/', views.delete_receita.as_view(), name='delete'),
    path('<int:receita_id>/', views.detail_receita, name='detail'),
    path('<int:receita_id>/comentar', views.create_comentario, name='comentar'),
]

receitas/models.py
from django.db import models
from django.conf import settings

# Create your models here.

class Post(models.Model):
    title_post = models.CharField(max_length=255)
    data_post = models.DateTimeField()
    desc_post = models.CharField(max_length=1000, null=True)
    conteudo = models.CharField(max_length=10000)

    def __str__(self):
        return f'{self.title_post} ({self.data_post}) - {self.conteudo}'

class Comentario(models.Model):
    author = models.ForeignKey(settings.AUTH_USER_MODEL,
                               on_delete=models.CASCADE)
    data_post = models.DateTimeField()
    text = models.CharField(max_length=255)
    post = models.ForeignKey(Post, on_delete=models.CASCADE)

    def __str__(self):
        return f'"{self.text}" - {self.author.username}'

class Category(models.Model):
    name_cat = models.CharField(max_length=255)
    desc_cat = models.CharField(max_length=255)
    post = models.ManyToManyField(Post)

    def __str__(self):
        return f'{self.name_cat}'

receitas/forms.py
from django.forms import ModelForm
from .models import Post,Comentario


class ComentForm(ModelForm):
    class Meta:
        model = Comentario
        fields = [
            'author',
            'data_post',
            'text',
        ]
        labels = {
            'author': 'Usuário',
            'data_post': 'Data de postagem',
            'text': 'Comentario',
        }

receitas/views.py
from django.shortcuts import render,  get_object_or_404
from .models import Post
from django.http import HttpResponseRedirect
from django.urls import reverse
from .models import Post, Comentario, Category
from .forms import ComentForm
from django.views import generic
from django.urls import reverse_lazy

import receitas

# Create your views here.
class list_receita(generic.ListView):
    model = Post
    template_name = 'receitas/index.html'
    def get_queryset(self):
        recei=Post.objects.all()
        context = {'titulo':"Todas as receitas",'posts': recei}
        return context

class list_cat(generic.ListView):
    model = Category
    template_name = 'receitas/categorias.html'

class detail_cat(generic.ListView):
    template_name = 'receitas/index.html'
    def get_queryset(self):
        cate = get_object_or_404(Category, pk=self.kwargs['pk'])
        recei=cate.post.all()
        context = {'titulo':cate.name_cat,'posts': recei}
        return context

def detail_receita(request, receita_id):
    receita = get_object_or_404(Post, pk=receita_id)
    context = {'Post': receita}
    return render(request, 'receitas/detail.html', context)

def create_receita(request):
    if request.method == 'POST':
        post_title = request.POST['title']
        post_data = request.POST['data']
        post_desc = request.POST['desc']
        post_conteudo = request.POST['conteudo']
        rece = Post(title_post=post_title,
                      data_post=post_data,
                      desc_post=post_desc,
                      conteudo=post_conteudo)
        rece.save()
        return HttpResponseRedirect(
            reverse('receitas:detail', args=(rece.id, )))
    else:
        return render(request, 'receitas/create.html', {})

def create_comentario(request, receita_id):
    rece = get_object_or_404(Post, pk=receita_id)
    if request.method == 'POST':
        form = ComentForm(request.POST)
        if form.is_valid():
            comen_author = form.cleaned_data['author']
            comen_data = form.cleaned_data['data_post']
            comen_coment= form.cleaned_data['text']
            comen = Comentario(author=comen_author,
                            data_post=comen_data,
                            text=comen_coment,
                            post=rece)
            comen.save()
            return HttpResponseRedirect(
                reverse('receitas:detail', args=(receita_id, )))
    else:
       form = ComentForm()
    context = {'form': form, 'receita': rece}
    return render(request, 'receitas/comentar.html', context)

def update_receita(request, receita_id):
    receita = get_object_or_404(Post, pk=receita_id)

    if request.method == "POST":
        receita.title_post = request.POST['title']
        receita.data_post = request.POST['data']
        receita.desc_post = request.POST['desc']
        receita.conteudo = request.POST['conteudo']
        receita.save()
        return HttpResponseRedirect(
            reverse('receitas:detail', args=(receita.id, )))

    context = {'receita': receita}
    return render(request, 'receitas/update.html', context)

class delete_receita(generic.DeleteView):
    model = Post
    context_object_name = 'Post'
    template_name = 'receitas/delete.html'
    success_url = reverse_lazy('receitas:index')

receitas/templates/receitas/categorias.html
{% extends 'base.html' %}

{% block content %}
<center>
<h1>Todas as categorias {{pk}}</h1>
</center>
<br>
<hr>
{% if object_list %}
<section>
    {% for categoria in object_list %}
    <article class="card">
        <center><h3>{{ categoria.name_cat }}</h3></center>
        <p class="div_main">{{ categoria.desc_cat }}</p>
        <center><a  href="{% url 'receitas:cat_indiv' categoria.id %}" class="btn_link"><div class="btn_cria">Visualizar</div></a></center>
    </article>
    <hr>
    {% endfor %}
</section>
{% else %}
<p>Não foi encontrada nenhuma categoria.</p>
{% endif %}

{% endblock content %}

receitas/templates/receitas/comentar.html
{% extends 'base.html' %}

{% block content %}
<center><h1>Inserir Novo Comentário para {{receita.title_post}}</h1></center>
<hr>
<form method="POST" action="{% url 'receitas:comentar' receita.id%}">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Criar</button>
</form>

{% endblock content %}

receitas/templates/receitas/create.html
{% extends 'base.html' %}

{% block content %}
<center><h1>Inserir Nova Receita</h1></center>
<hr>
<form method="POST" action="{% url 'receitas:create' %}">
    {% csrf_token %}
    <p>
        <label for="id_title">Título:</label><br>
        <input type="text" name="title" id="id_title" />
    </p>
    <p>
        <label for="id_data">Descrição:</label><br>
        <input type="datetime-local" name="data" id="id_data" />
    </p>
    <p>
        <label for="id_release_year">Descrição:</label><br>
        <textarea name="desc" id="id_desc" rows="5" cols="100" style="resize: none;">Insira a descrição do prato</textarea>
    </p>
    <p>
        <label for="id_conteudo">Conteúdo::</label><br>
        <textarea name="conteudo" id="id_conteudo"  rows="10" cols="100" style="resize: none;">Insira o código da receita</textarea>
    </p>
    <button type="submit">Criar</button>
</form>

{% endblock content %}

receitas/templates/receitas/delete.html
{% extends 'base.html' %}

{% block content %}
<form action="{% url 'receitas:delete' Post.id %}" method="post">
    {% csrf_token %}
    <center>
    <p>
        Você tem certeza que deseja apagar a receita "{{ Post.title_post }}"?
    </p>
    <button type="submit">Apagar</button>
    </center>
</form>

{% endblock content %}

receitas/templates/receitas/detail.html
{% extends 'base.html' %}

{% block title %}
{{ Post.title_post }}
{% endblock title %}

{% block content %}
<center>
<h1>{{ Post.title_post }}</h1>
<h5>
{% if Post.category_set.all %}
|
    {% for categ in Post.category_set.all%}
        <a href="{% url 'receitas:cat_indiv' categ.id %}">{{ categ.name_cat }} |</a>
    {% endfor %}
{% endif %}
</h5>
<h6>{{ Post.data_post }}</h6>
</center>
<a href="{% url 'receitas:update' Post.id %}" class="btn_link"><div class="btn_cria">Atualizar receita</div></a>
<section>
    <hr>
    {{ Post.conteudo | safe}}
    <br>
    <br>
    <br>
    <a href="{% url 'receitas:delete' Post.id %}" class="btn_delete_link"><div class="btn_delete">Apagar receita</div></a>
    <hr>
    <h3>Comentários</h3>
    {% if Post.comentario_set.all %}
        {% for comentario in Post.comentario_set.all|dictsortreversed:"data_post"%}
            <figure>
                <blockquote>
                    "{{ comentario.text }}"
                </blockquote>
                <figcaption>—{{ comentario.author }} ({{ comentario.data_post }})
            </figure>
            <hr>
        {% endfor %}
    {% else %}
        <p>Sem comentários...</p>
    {% endif %}
    <a href="{% url 'receitas:comentar' Post.id %}" class="btn_link"><div class="btn_cria">Comentar</div></a>
    <hr>
</section>
{% endblock content %}

receitas/templates/receitas/index.html
{% extends 'base.html' %}

{% block content %}
<center>
<h1>{{object_list.titulo}}</h1>
</center>
<a  href="{% url 'receitas:create' %}" class="btn_link"><div class="btn_cria">Adicionar receita</div></a>
<hr>
{% if object_list.posts %}
<section>
    {% for receita in object_list.posts %}
    <article class="card">
        <center><h3>{{ receita.title_post }}</h3></center>
        <p class="div_main">{{ receita.desc_post }}</p>
        <center><a  href="{% url 'receitas:detail' receita.id %}" class="btn_link"><div class="btn_cria">Visualizar</div></a></center>
    </article>
    <hr>
    {% endfor %}
</section>
{% else %}
<p>Não foi encontrada nenhuma receita.</p>
{% endif %}

{% endblock content %}

receitas/templates/receitas/update.html
{% extends 'base.html' %}

{% block content %}
<center>
<h1>Editar Receita</h1>
<h3>{{receita.title_post}}</h3>
</center>
<hr>
<form method="POST" action="{% url 'receitas:update' receita.id %}">
    {% csrf_token %}
    <p>
        <label for="id_title">Título:</label><br>
        <input type="text" name="title" id="id_title" value="{{receita.title_post}}"/>
    </p>
    <p>
        <label for="id_data">Descrição:</label><br>
        <input type="datetime-local" name="data" id="id_data" value="{{receita.data_post|date:"Y-m-d"}}T{{receita.data_post|time:"H:i"}}"/>
    </p>
    <p>
        <label for="id_release_year">Descrição:</label><br>
        <textarea name="desc" id="id_desc" rows="5" cols="100" style="resize: none;">{{receita.desc_post}}</textarea>
    </p>
    <p>
        <label for="id_conteudo">Conteúdo::</label><br>
        <textarea name="conteudo" id="id_conteudo"  rows="10" cols="100" style="resize: none;">{{receita.conteudo}}</textarea>
    </p>
    <button type="submit">Atualizar</button>
</form>

{% endblock content %}

templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" type="text/css" href="{% static 'style.css' %}">
    <title>{% block title %}{% endblock %}</title>
</head>
<body>
    <header>
        <nav>
            <img class="logo" src="{% static 'Main_Logo.png' %}" alt="logo">
            <a href="{% url 'index' %}" class="navbut"><div class="divnav">Home</div></a>
            <a href="{% url 'receitas:index' %}" class="navbut"><div class="divnav">Receitas</div></a>
            <a href="{% url 'receitas:categorias' %}" class="navbut"><div class="divnav">Categorias</div></a>
            <a href="{% url 'about' %}" class="navbut"><div class="divnav">Sobre</div></a>
        </nav>
    </header>
    <main>
        {% block content %}
        {% endblock content %}
    </main>
    <footer>
        <p class="footer_text">Copyright 2021 Carlos Eugênio Lucas NUSP:11259416.</p>
    </footer>
</body>

</html>